



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Redis常用数据类型及命令</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Redis常用数据类型及命令</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 20:12:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Redis数据类型</h2>
<p>Redis支持五种数据类型：string（字符串），hash（哈希），list（列表），set（集合）及zset(sorted set：有序集合)。</p>
<p>注意：</p>
<p>命令的关键词，如set,get,lpush,zadd等不区分大小写。。</p>
<p>但是<strong>key一定要注意区分大小写。</strong></p>
<h3>String(字符串)</h3>
<p>通过 set 设置 key对应的value，再通过get获取key对应的value。</p>
<div>
<pre class="prettyprint linenums">test:0&gt;set name  "lin"<br />
OK

test:0&gt;get name<br />
"lin"</pre>
</div>
<h3>Hash(哈希)</h3>
<p>Redis Hmset 命令用于同时将多个 field-value (字段-值)对设置到哈希表中。</p>
<p>此命令会覆盖哈希表中已存在的字段。</p>
<p>如果哈希表不存在，会创建一个空哈希表，并执行 HMSET 操作。</p>
<p>hmset的基本语法如下：</p>
<div>
<pre class="prettyprint linenums">HMSET KEY_NAME FIELD1 VALUE1 ...FIELDN VALUEN  </pre>
</div>
<p>如果只设置一个field，则使用hset，如下：</p>
<div>
<pre class="prettyprint linenums">HSET KEY_NAME FIELD VALUE </pre>
</div>
<p>获取存储在哈希表中指定字段的值，如下：</p>
<div>
<pre class="prettyprint linenums">HGET key field</pre>
</div>
<p>示例如下：</p>
<div>
<pre class="prettyprint linenums">test:0&gt;hmset myhashkey field1 "hello" field2 "world"<br />
OK

test:0&gt;hget myhashkey field1<br />
"hello"

test:0&gt;hget myhashkey field2<br />
"world"

test:0&gt;hgetall myhashkey<br />field1<br />"hello"<br />field2<br />"world"

</pre>
</div>
<h3>List(列表)</h3>
<p>list添加数据如下：</p>
<div>
<pre class="prettyprint linenums">LPUSH key value1 [value2]      将一个或多个值插入到列表头部</pre>
</div>
<p>list遍历数据如下：</p>
<p>Redis Lrange 返回列表中指定区间内的元素，区间以偏移量 START 和 END 指定。 其中 0 表示列表的第一个元素， 1 表示列表的第二个元素，以此类推。 你也可以使用负数下标，以 -1 表示列表的最后一个元素， -2 表示列表的倒数第二个元素，以此类推。</p>
<div>
<pre class="prettyprint linenums">LRANGE KEY_NAME START END</pre>
</div>
<p>lpush&nbsp;l是left，也就是从左边开始添加。需要注意的是，继续从左边添加数据，已添加的数据会向右移。</p>
<p>因此，遍历时的顺序与插入时的顺序相反。</p>
<p>(rpush r是right，也就是从右边开始添加。)</p>
<p>list移除数据如下：</p>
<p>Lpop 命令用于移除并返回列表的第一个元素。</p>
<div>
<pre class="prettyprint linenums">Lpop KEY_NAME </pre>
</div>
<p>示例如下：</p>
<div>
<pre class="prettyprint linenums">test:0&gt;lpush order order1<br />
1

test:0&gt;lpush order order2<br />
2

test:0&gt;lpush order order3<br />
3

test:0&gt;lrange order 0 2<br />
order3<br />
order2<br />
order1

test:0&gt;lpop order <br />order3

test:0&gt;lrange order 0 2<br />order2<br />order1</pre>
</div>
<h3>Set(集合)</h3>
<p>Redis的Set是string类型的无序不重复的集合。</p>
<p>sadd 命令：添加一个 string 元素到 key 对应的 set 集合中，成功返回1，如果元素已经在集合中返回 0，如果 key 对应的 set 不存在则返回错误。</p>
<p>如果添加多个元素，那么就会返回元素的个数。</p>
<div>
<pre class="prettyprint linenums">sadd key 元素1 元素2 元素3 ...</pre>
</div>
<p>smembers命令：遍历set集合</p>
<div>
<pre class="prettyprint linenums">smembers key</pre>
</div>
<p>示例如下：</p>
<div>
<pre class="prettyprint linenums">test:0&gt;sadd mySet "redis"<br />
1

test:0&gt;sadd mySet "mongodb"<br />
1

test:0&gt;sadd mySet "couchdb"<br />
1<br />
<br />//因为元素"couchdb"已经存在，所以无法再次添加，返回结果0.<br />
test:0&gt;sadd mySet "couchdb"<br />
0<br />
<br />//遍历集合<br />
test:0&gt;smembers mySet<br />
"couchdb"<br />
"mongodb"<br />
"redis"<br />
<br />//添加多个元素的示例如下：<br />
test:0&gt; sadd set-test&nbsp; c java c++<br />(integer) 3</pre>
<pre class="prettyprint linenums"></pre>
</div>
<h3>zset(sorted set：有序集合)</h3>
<p>Redis zset 和 set 一样也是string类型元素的集合,且不允许重复的成员。</p>
<p>不同的是每个元素都会关联一个double类型的分数。redis正是通过分数来为集合中的成员进行从小到大的排序。</p>
<p>zset的成员是唯一的,但分数(score)却可以重复。</p>
<p>zadd 命令：添加元素到集合，元素在集合中存在则更新对应score</p>
<div>
<pre class="prettyprint linenums">zadd key score 元素内容 </pre>
</div>
<p>注意：命令的关键词，如zadd等不区分大小写。。但是key一定要注意区分大小写。</p>
<p>示例如下：</p>
<div>
<pre class="prettyprint linenums">test:0&gt;zadd  myZSet 0 "spring"<br />
1

test:0&gt;zadd  myZSet 0 "springboot"<br />
1

test:0&gt;zadd  myZSet 1 "mybatis"<br />
1<br />
<br />--注意：key要区分大小写。以下的myzset写错了，所以查不出结果<br />
test:0&gt;zrangebyscore myzset 0  1

test:0&gt;zrangebyscore myZSet 0  1<br />
"spring"<br />
"springboot"<br />
"mybatis"

test:0&gt;</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mlor9k.html">Android程序中--不能改变的事情</a>
		</li>
						<li><a href="https://www.batexi.com/a/495xlzz8.html">Genymotion安装问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdg740q.html">Linux grep与正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93lkon9.html">9 DelayQueueEntry 延时队列节点类&mdash;&mdash;Live555源码阅读&lpar;一&rpar;基本组件类</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7p5nkq.html">微信支付开发&lpar;11&rpar; Native支付</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wdokxq.html">改变CSS样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z51109.html">最全的PHP常用函数大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k126zr9.html">数据库连接字符串ConnectionString 中的关键字值释义</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnkgr6q.html">RDDTest&period;scala</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y6xvjq.html">&amp;lt&semi;六&amp;gt&semi; jQuery 获得内容和属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yokv08.html">jQuery UI Widget 原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppp779.html">HT for Web嵌入QtWebKit的client解决方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjn738.html">Android 儿子Activity在启动过程中的流程组件 &amp;amp&semi;amp&semi;&amp;amp&semi;amp&semi; 儿子Activity在一个新的进程组件启动过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me5kmoq.html">金三银四，今年Python就业前，看看这篇文章找找感觉</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgen2e8.html">开始使用Filebeat</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rrdwm9.html">kSum问题总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2k2519.html">pytest 3&period;9在python 2&period;7下的一个bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wrjprq.html">三篇文章带你极速入门php（三）之php原生实现登陆注册</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnverzj8.html">WinRAR 5&period;40 &amp;amp&semi; 4&period;20 &amp;amp&semi; 3&period;93 的注册码 - rarreg&period;key</a>
		</li>
						<li><a href="https://www.batexi.com/a/8komm37q.html">Python标准异常和异常处理详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4pnemnq.html">print 出来的信息添加到text文件里</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko5347q.html">R语言学习&mdash;&mdash;条件筛选</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko5367q.html">POJ 1182 食物链&lpar;并查集的使用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k074oq.html">学习笔记之Elasticsearch</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7egxdk9.html">var abc &equals; function&lpar;x&rpar;&lbrace;&rcub; 和 function abc&lpar;x&rpar;&lbrace;&rcub;的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vlm24q.html">MYSQL ERROR 1045 &lpar;28000&rpar;&colon; Access denied for user &lpar;using password&colon; YES&rpar;解决方案详细说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/qver5ny9.html">override的实现原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp5md09.html">ThinkPHP 5使用 Composer  组件名称可以从https&colon;&sol;&sol;packagist&period;org&sol; 搜索到</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv5d0jq.html">CA证书认证单向和双向的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp5e409.html">VS2013下&period;Net Framework4配置FineUI4&period;14</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
